﻿namespace TestLibrary
{
    /// <summary>
    /// JSON 클래스 제너레이터 인터페이스
    /// </summary>
    public interface IJSONClassGenerator
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Property

        #region 네임스페이스 - Namespace

        /// <summary>
        /// 네임스페이스
        /// </summary>
        string Namespace { get; set; }

        #endregion
        #region 보조 네임스페이스 - SecondaryNamespace

        /// <summary>
        /// 보조 네임스페이스
        /// </summary>
        string SecondaryNamespace { get; set; }

        #endregion
        #region 속성 사용 여부 - UseProperties

        /// <summary>
        /// 속성 사용 여부
        /// </summary>
        bool UseProperties { get; set; }

        #endregion
        #region 내부 표시 여부 - InternalVisibility

        /// <summary>
        /// 내부 표시 여부
        /// </summary>
        bool InternalVisibility { get; set; }

        #endregion
        #region 명시적 역직렬화 - ExplicitDeserialization

        /// <summary>
        /// 명시적 역직렬화
        /// </summary>
        bool ExplicitDeserialization { get; set; }

        #endregion
        #region 헬퍼 클래스 없음 여부 - NoHelperClass

        /// <summary>
        /// 헬퍼 클래스 없음 여부
        /// </summary>
        bool NoHelperClass { get; set; }

        #endregion
        #region 메인 클래스 - MainClass

        /// <summary>
        /// 메인 클래스
        /// </summary>
        string MainClass { get; set; }

        #endregion
        #region 파스칼 표기법 사용 여부 - UsePascalCase

        /// <summary>
        /// 파스칼 표기법 사용 여부
        /// </summary>
        bool UsePascalCase { get; set; }

        #endregion
        #region 중첩 클래스 사용 여부 - UseNestedClasses

        /// <summary>
        /// 중첩 클래스 사용 여부
        /// </summary>
        bool UseNestedClasses { get; set; }

        #endregion
        #region 난독화 어트리뷰트 적용 여부 - ApplyObfuscationAttributes

        /// <summary>
        /// 난독화 어트리뷰트 적용 여부
        /// </summary>
        bool ApplyObfuscationAttributes { get; set; }

        #endregion
        #region 단일 파일 여부 - SingleFile

        /// <summary>
        /// 단일 파일 여부
        /// </summary>
        bool SingleFile { get; set; }

        #endregion
        #region 코드 작성자 - CodeWriter

        /// <summary>
        /// 코드 작성자
        /// </summary>
        ICodeWriter CodeWriter { get; set; }

        #endregion
        #region 보조 클래스 보유 여부 - HasSecondaryClasses

        /// <summary>
        /// 보조 클래스 보유 여부
        /// </summary>
        bool HasSecondaryClasses { get; }

        #endregion
        #region NULL 가능 값 항상 사용 여부 - AlwaysUseNullableValues

        /// <summary>
        /// NULL 가능 값 항상 사용 여부
        /// </summary>
        bool AlwaysUseNullableValues { get; set; }

        #endregion
        #region 네임스페이스 사용 여부 - UseNamespaces

        /// <summary>
        /// 네임스페이스 사용 여부
        /// </summary>
        bool UseNamespaces { get; }

        #endregion
        #region 문서 내 예제 여부 - ExamplesInDocumentation

        /// <summary>
        /// 문서 내 예제 여부
        /// </summary>
        bool ExamplesInDocumentation { get; set; }

        #endregion
    }
}