﻿namespace TestLibrary
{
    /// <summary>
    /// JSON 값 타입
    /// </summary>
    public enum JSONValueType
    {
        /// <summary>
        /// ANYTHING
        /// </summary>
        Anything,

        /// <summary>
        /// 문자열
        /// </summary>
        String,

        /// <summary>
        /// 진리값
        /// </summary>
        Boolean,

        /// <summary>
        /// 정수
        /// </summary>
        Integer,

        /// <summary>
        /// 배정도 정수
        /// </summary>
        Long,

        /// <summary>
        /// 부동형 실수
        /// </summary>
        Float,

        /// <summary>
        /// 날짜
        /// </summary>
        Date,

        /// <summary>
        /// NULL 가능 정수
        /// </summary>
        NullableInteger,

        /// <summary>
        /// NULL 가능 배정도 정수
        /// </summary>
        NullableLong,

        /// <summary>
        /// NULL 가능 부동형 실수
        /// </summary>
        NullableFloat,

        /// <summary>
        /// NULL 가능 진리값
        /// </summary>
        NullableBoolean,

        /// <summary>
        /// NULL 가능 날짜
        /// </summary>
        NullableDate,

        /// <summary>
        /// 객체
        /// </summary>
        Object,

        /// <summary>
        /// 배열
        /// </summary>
        Array,

        /// <summary>
        /// 딕셔너리
        /// </summary>
        Dictionary,

        /// <summary>
        /// NULL 가능 SOMETHING
        /// </summary>
        NullableSomething,

        /// <summary>
        /// 제약 없음
        /// </summary>
        NonConstrained
    }
}